Enable OpenDaylight clustering mode for FDIO scenarios
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       elif [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       else
42         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
43       fi
44     else
45       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
46     fi
47     SDN_IMAGE=opendaylight
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
49     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
50     SDN_IMAGE=opendaylight
51   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
52     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
53     exit 1
54     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
56     #else
57     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
58     #fi
59     #SDN_IMAGE=onos
60   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
61     if [[ "$ha_enabled" == "True" ]]; then
62       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
63       echo "${red}OVN HA support is not not supported... exiting.${reset}"
64       exit 1
65     else
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
70     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
71     exit 1
72   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
73     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
74     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
76     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
77       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
78     fi
79     SDN_IMAGE=opendaylight
80   else
81     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
82     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
83     exit 1
84   fi
85
86   # Enable Tacker
87   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
88     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
89   fi
90
91   # Enable Congress
92   if [ "${deploy_options_array['congress']}" == 'True' ]; then
93     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
94   fi
95
96   # Enable Real Time Kernel (kvm4nfv)
97   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
98     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
99   fi
100
101   # Make sure the correct overcloud image is available
102   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
103       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
104       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
105       exit 1
106   fi
107
108   echo "Copying overcloud image to Undercloud"
109   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
110   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
111
112   # disable neutron openvswitch agent from starting
113   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
114       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
115       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
116       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
117                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
118                                                -a overcloud-full.qcow2
119 EOI
120   fi
121
122   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
123       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
124       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
125       LIBGUESTFS_BACKEND=direct virt-customize \
126          --run-command "systemctl enable zrpcd" \
127          --run-command "systemctl enable bgpd" \
128          -a overcloud-full.qcow2
129 EOI
130   fi
131
132   # Install ovs-dpdk inside the overcloud image if it is enabled.
133   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
134     # install dpdk packages before ovs
135     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
136
137     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
138       cat << EOF > vfio_pci.modules
139 #!/bin/bash
140 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
141 EOF
142
143       cat << EOF > uio_pci_generic.modules
144 #!/bin/bash
145 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
146 EOF
147
148       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
149                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
150                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
151                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
152                                                -a overcloud-full.qcow2
153
154       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
155         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
156       fi
157
158 EOI
159
160   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
161     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
162     exit 1
163   fi
164
165   if [ "$debug" == 'TRUE' ]; then
166     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
167   fi
168
169   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
170   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
171     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
172          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
173                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
174                                                   -a overcloud-full.qcow2
175 EOI
176   fi
177
178   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
179   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
180     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
181       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
182                                                -a overcloud-full.qcow2
183 EOI
184
185     # Configure routing node for odl-fdio
186     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
187       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
188         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
189 EOI
190     fi
191   fi
192
193   if [ -n "${deploy_options_array['performance']}" ]; then
194     ovs_dpdk_perf_flag="False"
195     for option in "${performance_options[@]}" ; do
196       if [ "${arr[1]}" == "vpp" ]; then
197         if [ "${arr[0]}" == "Compute" ]; then
198           role='NovaCompute'
199         else
200           role=${arr[0]}
201         fi
202         if [ "${arr[2]}" == "main-core" ]; then
203           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
204             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: \"'${arr[3]}'\"" ${ENV_FILE}
205 EOI
206         elif [ "${arr[2]}" == "corelist-workers" ]; then
207           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
208             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: \"'${arr[3]}'\"" ${ENV_FILE}
209 EOI
210         fi
211       fi
212       arr=($option)
213       # use compute's kernel settings for all nodes for now.
214       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
215         kernel_args+=" ${arr[2]}=${arr[3]}"
216       fi
217       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
218          eval "${arr[2]}=${arr[3]}"
219          ovs_dpdk_perf_flag="True"
220       fi
221     done
222
223     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
224       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
225       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
226       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
227 EOI
228
229     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
230       for ovs_option in ${!ovs_option_heat_arr[@]}; do
231         if [ -n "${!ovs_option}" ]; then
232           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
233             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
234 EOI
235         fi
236       done
237     fi
238   fi
239
240   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
241     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
242       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
243         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
244         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
245           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
246 EOI
247       else
248         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
249         exit 1
250       fi
251     fi
252   fi
253
254   # Set ODL version accordingly
255   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
256     case "${deploy_options_array['odl_version']}" in
257       beryllium) odl_version=''
258               ;;
259       boron)  odl_version='boron'
260               ;;
261       carbon) odl_version='master'
262               ;;
263       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
264          exit 1
265          ;;
266     esac
267
268     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
269       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
270                                                --run-command "yum -y install /root/${odl_version}/*" \
271                                                -a overcloud-full.qcow2
272 EOI
273   fi
274
275   # Override ODL if we enable netvirt for fdio
276   if [[ "${deploy_options_array['odl_vpp_netvirt']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
277     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
278       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
279                                                --run-command "tar zxvf /root/odl-netvirt-vpp-distribution.tar.gz -C /opt/opendaylight/" \
280                                                -a overcloud-full.qcow2
281 EOI
282   fi
283
284   # check if ceph should be enabled
285   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
286     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
287   fi
288
289   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
290     # The epoch in deloran's ovs is 1: and in leif's is 0:
291     # so we have to execute a downgrade instead of an update
292     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
293       LIBGUESTFS_BACKEND=direct virt-customize \
294         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
295         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
296         -a overcloud-full.qcow2
297 EOI
298   fi
299
300   # get number of nodes available in inventory
301   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
302   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
303
304   # check if HA is enabled
305   if [[ "$ha_enabled" == "True" ]]; then
306     if [ "$num_control_nodes" -lt 3 ]; then
307       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
308       exit 1
309     else
310      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
311      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
312      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
313     fi
314   else
315     if [ "$num_control_nodes" -lt 1 ]; then
316       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
317       exit 1
318     fi
319   fi
320
321   if [ "$num_compute_nodes" -le 0 ]; then
322     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
323     exit 1
324   else
325     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
326     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
327   fi
328
329   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
330
331   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
332   if [[ "$virtual" == "TRUE" ]]; then
333     DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
334   else
335     DEPLOY_OPTIONS+=" -e baremetal-environment.yaml"
336   fi
337
338   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
339
340   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
341 # Create a key for use by nova for live migration
342 echo "Creating nova SSH key for nova resize support"
343 ssh-keygen -f nova_id_rsa -b 1024 -P ""
344 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
345 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
346 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
347 mv -f opnfv-environment-new.yaml ${ENV_FILE}
348
349 source stackrc
350 set -o errexit
351 # Workaround for APEX-207 where sometimes swift proxy is down
352 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
353   sudo systemctl restart openstack-swift-proxy
354 fi
355 echo "Uploading overcloud glance images"
356 openstack overcloud image upload
357
358 echo "Configuring undercloud and discovering nodes"
359 openstack baremetal import --json instackenv.json
360
361 if [[ -z "$virtual" ]]; then
362   openstack baremetal introspection bulk start
363   if [[ -n "$root_disk_list" ]]; then
364     openstack baremetal configure boot --root-device=${root_disk_list}
365   else
366     openstack baremetal configure boot
367   fi
368 else
369   openstack baremetal configure boot
370 fi
371
372 echo "Configuring flavors"
373 for flavor in baremetal control compute; do
374   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
375   if openstack flavor list | grep \${flavor}; then
376     openstack flavor delete \${flavor}
377   fi
378   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
379   if ! openstack flavor list | grep \${flavor}; then
380     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
381   fi
382 done
383 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
384 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
385 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
386 echo "Configuring nameserver on ctlplane network"
387 dns_server_ext=''
388 for dns_server in ${dns_servers}; do
389   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
390 done
391 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
392 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
393 echo "Executing overcloud deployment, this should run for an extended period without output."
394 sleep 60 #wait for Hypervisor stats to check-in to nova
395 # save deploy command so it can be used for debugging
396 cat > deploy_command << EOF
397 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
398 EOF
399 EOI
400
401   if [ "$interactive" == "TRUE" ]; then
402     if ! prompt_user "Overcloud Deployment"; then
403       echo -e "${blue}INFO: User requests exit${reset}"
404       exit 0
405     fi
406   fi
407
408   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
409 source stackrc
410 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
411 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
412   $(typeset -f debug_stack)
413   debug_stack
414   exit 1
415 fi
416 EOI
417
418   # Configure DPDK and restart ovs agent after bringing up br-phy
419   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
420     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
421 source stackrc
422 set -o errexit
423 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
424 echo "Checking DPDK status and bringing up br-phy on \$node"
425 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
426 set -o errexit
427 sudo dpdk-devbind -s
428 sudo ifup br-phy
429 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
430   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
431   sudo systemctl restart neutron-openvswitch-agent
432 fi
433 EOF
434 done
435 EOI
436   fi
437
438   if [ "$debug" == 'TRUE' ]; then
439       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
440 source overcloudrc
441 echo "Keystone Endpoint List:"
442 openstack endpoint list
443 echo "Keystone Service List"
444 openstack service list
445 EOI
446   fi
447 }